#include "../include/aprecv-general.h"

static const char *bgptype[]= {
	" (Unknown)",
	" (Open)",
	" (Update)",
	" (Notification)",
	" (Keep-alive)",
	" (Route-refresh)",
};

int print_bgp_packet (unsigned char *packet, int opt_size) {
  static struct bgp_pkt_header *bgp_header;
  static unsigned short i=0;
  
  bgp_header = (struct bgp_pkt_header *)(packet+data_link_size+opt_size);
  
  apsr_output("- BGP Header -\n  Marker: \"");
  for(i = 0; i <= 15; i++) {
	  if(isprint(bgp_header->marker[i]))
		  apsr_output("%c", bgp_header->marker[i]);
          else
		  apsr_output(".");
  }
  apsr_output("\"\n  Length: %u, Type: %u", ntohs(bgp_header->length), 
		  bgp_header->type); 

  if(verbose) 
	  apsr_output("%s", bgptype[bgp_header->type]);
  
  apsr_output("\n");
	
  if(statistic)
	stats.c.bgp++;
  
  return(RET_SUCCESS);
}
