#include "../include/aprecv-general.h"

int print_chdlc_packet (struct aprecv_frame_header *header, unsigned char *packet, int opt_size) {
  struct chdlc_pkt_header *chdlc_header;
  unsigned short ethernet_type=0;

  chdlc_header = (struct chdlc_pkt_header *) packet;
  ethernet_type = apsr_ntohs(chdlc_header->protocol);
  
  apsr_output("\n- Cisco HDLC Header -\n");

  apsr_output("  Address: 0x%02x", chdlc_header->address);
  if(verbose) {
	  switch(chdlc_header->address) {
		  case APSR_CHDLC_ADDRESS_UNICAST:
			  apsr_output(" (Unicast)");
			  break;
		  case APSR_CHDLC_ADDRESS_MULTICAST:
			  apsr_output(" (Multicast)");
			  break;
		  default:
			  apsr_output(" (Unknown)");
			  break;
	  }			  
  }  			 
	  
  apsr_output("\n  Protocol: 0x%04x", ethernet_type);
  if(verbose)
	  print_ethernet_proto(ethernet_type);
  
  switchto_ethernet_proto(header, packet, opt_size, ethernet_type);

  if(statistic)
	  stats.c.chdlc++;

  return(RET_SUCCESS);
}

