#include "../include/aprecv-general.h"

static const char *irtptypes[]= {
	" (Synch)",
	" (Synch Ack)",
	" (Data)",
	" (Data Ack)",
	" (Port Nak)",
};

int print_irtp_packet (struct aprecv_frame_header *header, unsigned char *packet, int opt_size) {
  static struct irtp_pkt_header *irtp_header;
  static unsigned short pkt_checksum, correct_checksum;

  irtp_header = (struct irtp_pkt_header *)(packet+data_link_size+opt_size);
  
  apsr_output("- IRTP Header -\n  Type: %d", irtp_header->type);
  if(verbose) 
	apsr_output("%s", irtptypes[irtp_header->type]);

  apsr_output("\n  Port: %d, Sequence number: %u",(int) irtp_header->port, 
		  apsr_ntohs(irtp_header->seq_num));

  pkt_checksum = apsr_ntohs(irtp_header->sum);
  apsr_output("\n  Length: %u, Checksum: 0x%04x", irtp_header->length, 
		  pkt_checksum);

  if(calc_checksums) {
    irtp_header->sum=0x0000;
    correct_checksum=apsr_ntohs(in_cksum((unsigned short *)irtp_header, 
	sizeof(struct irtp_pkt_header)+(header->len-data_link_size-opt_size),
	0));
    if(pkt_checksum == correct_checksum) {
	    apsr_output(" (correct checksum)");
    } 
    else {
	    apsr_output(" (incorrect checksum - should be 0x%04x)", 
			    correct_checksum);

            if(statistic)
		    stats.cr.irtp++;
    }
  }

  apsr_output("\n");
  
  if(statistic) 
          stats.c.irtp++;
  
  return(RET_SUCCESS);
}
