#include "../include/aprecv-general.h"

static const char *msdp_types[]= {
	" (Unknown)",
	" (IPv4 Source-Active)",
	" (SA-Request)",
	" (IPv4 Source-Active Response)",
	" (Keepalive)",
	" (Notification)",
};

int print_msdp_packet (unsigned char *packet, int opt_size) {
  static struct msdp_pkt_header *msdp_header;
  
  msdp_header = (struct msdp_pkt_header *)(packet+data_link_size+opt_size);
  
  apsr_output("- MSDP Header -\n  Type: %u", msdp_header->type);
  if(verbose)
	  apsr_output("%s", msdp_types[msdp_header->type]);

  apsr_output("\n  Length: %u\n", apsr_ntohs(msdp_header->length)); 
	
  if(statistic)
	stats.c.msdp++;
  
  return(RET_SUCCESS);
}
