#include "../include/aprecv-general.h"

int print_pgm_packet (unsigned char *packet, int opt_size) {
  static struct pgm_pkt_header *pgm_header;

  pgm_header = (struct pgm_pkt_header *)(packet+data_link_size+opt_size);
  
  apsr_output("- PGM Header -\n  Src Port: %u, Dst Port: %u\n", 
		  apsr_ntohs(pgm_header->source_port), 
		  apsr_ntohs(pgm_header->dest_port));
  apsr_output("  Type: %u, Options: %u, Checksum: 0x%04x\n",
		  pgm_header->pgm_type,
		  pgm_header->options,
		  apsr_ntohs(pgm_header->sum));
  apsr_output("  Global Source ID: 0x%02x 0x%02x 0x%02x 0x%02x 0x%02x 0x%02x\n",
		  pgm_header->gsid[0],
		  pgm_header->gsid[1],
		  pgm_header->gsid[2],
		  pgm_header->gsid[3],
		  pgm_header->gsid[4],
		  pgm_header->gsid[5]);
  apsr_output("  TSDU Length: %u\n", 
		  apsr_ntohs(pgm_header->tsdu_length));
  
  if(statistic) 
        stats.c.pgm++;
  
  return(RET_SUCCESS);
}
