#include "../include/aprecv-general.h"

int print_sdrp_packet (unsigned char *packet, int opt_size) {
  static struct sdrp_pkt_header *sdrp_header;
  char *target_router;
	
  /* TODO: Notification types */
  
  sdrp_header 	= (struct sdrp_pkt_header *)(packet+data_link_size+opt_size);
  target_router	= strdup(inet_ntoa(sdrp_header->target_router));
  
  apsr_output("- SDRP Header -\n  Version: %u", sdrp_header->version);

  apsr_output(", Data/Control Flag: %u, Loose/Strict Router: %u\n",
		  sdrp_header->data_ctrl_flag,
		  sdrp_header->loose_strict_route);

  apsr_output("  Probe Indicator: %u, Reserved: 0x%x, Hop Count: %u\n",
		  sdrp_header->probe_indicator,
		  sdrp_header->reserved,
		  sdrp_header->hop_count);
	  
  apsr_output("  Source Route Protocol: %u, Payload Protocol: %u\n", 
		  sdrp_header->source_route_protocol,
		  sdrp_header->payload_protocol_type);

  apsr_output("  Source Route Identifier: %u, Target Router: %s\n",
		  apsr_ntohl(sdrp_header->source_route_identifier),
		  target_router);

  apsr_output("  Prefix: %u, Prefix Length: %u, Notification: %u\n",
		  apsr_ntohl(sdrp_header->prefix),
		  sdrp_header->prefix_length,
		  sdrp_header->notification);

  apsr_output("  Source Route Length: %u, Next Hop Pointer: %u\n",
	  	  sdrp_header->source_route_length,
	          sdrp_header->next_hop_ptr);	
  
  if(statistic)
	  stats.c.sdrp++;
  
  return(RET_SUCCESS);
}
