#include "../include/apsrstack-general.h"

/* TODO: move later in scheduler.c */
void queue_check (int sig) {
        unsigned short x = 0;

	if(sig == SIGALRM) {
                for(x = 0; x < APSRSTACK_TCP_MAX_CONNECTIONS; x++) {
                  if(tcp_queue[x].state != APSRSTACK_TCP_STATE_LISTEN) {
                    tcp_queue[x].timeout = tcp_queue[x].timeout - APSRSTACK_TIMER_SEC;
 		    if(tcp_queue[x].timeout <= 0) {
                      tcp_queue[x].state = APSRSTACK_TCP_STATE_LISTEN;
                    }
 
                    apsr_output("%s : %u.%u.%u.%u:%u <-> %s:%u",
                               apsr_get_time_formatted(),
	 		       APSRSTACK_IP_1, APSRSTACK_IP_2,
                               APSRSTACK_IP_3, APSRSTACK_IP_4,
                               tcp_queue[x].local_port,
                               inet_ntoa(tcp_queue[x].peer_ip),
                               tcp_queue[x].peer_port);
                    switch(tcp_queue[x].state) { 
/* Should never happen ;-)
                      case APSRSTACK_TCP_STATE_LISTEN: 
                               apsr_output(" LISTEN");
                               break;
*/
                      case APSRSTACK_TCP_STATE_SYN_SENT:
                               apsr_output(" SYN-SENT");
                               break;
                      case APSRSTACK_TCP_STATE_SYN_RECEIVED:
                               apsr_output(" SYN-RECEIVED");
                               break;
                      case APSRSTACK_TCP_STATE_ESTABLISHED:
                               apsr_output(" ESTABLISHED");
                               break;
                      case APSRSTACK_TCP_STATE_FIN_WAIT_1:
                               apsr_output(" FIN_WAIT_1");
                               break;
                      case APSRSTACK_TCP_STATE_FIN_WAIT_2:
                               apsr_output(" FIN_WAIT_2");
                               break;
                      case APSRSTACK_TCP_STATE_CLOSE_WAIT:
                               apsr_output(" CLOSE-WAIT");
                               break;
                      case APSRSTACK_TCP_STATE_CLOSING:
                               apsr_output(" CLOSING");
                               break;
                      case APSRSTACK_TCP_STATE_LAST_ACK:
                               apsr_output(" LAST-ACK");
                               break;
                      case APSRSTACK_TCP_STATE_TIME_WAIT:
                               apsr_output(" TIME-WAIT");
                               break;
                      case APSRSTACK_TCP_STATE_CLOSED:
                               apsr_output(" CLOSED");
                               break;
                      default: apsr_output(" UNKNOWN");
                               break;
                    }
                    apsr_output(" %u", tcp_queue[x].timeout);
                    apsr_output("\n");
                  }
                }
        }

	if(signal(SIGALRM, (apsrstack_queue_check_callback)queue_check) == SIG_ERR) {
		#ifdef APSRSTACK_DEBUG
		apsr_stream_output(stderr, "Error: Signal error while SIGALRM catching.\n");
		#endif
        }
}

/* Main function */
int main (int argc, char **argv, char **env) {
  struct itimerval queue_timer;
  unsigned short c = 0;

  apsrstack_src_mac[0] = APSRSTACK_MAC_1;
  apsrstack_src_mac[1] = APSRSTACK_MAC_2;
  apsrstack_src_mac[2] = APSRSTACK_MAC_3;
  apsrstack_src_mac[3] = APSRSTACK_MAC_4;
  apsrstack_src_mac[4] = APSRSTACK_MAC_5;
  apsrstack_src_mac[5] = APSRSTACK_MAC_6;
  
  apsrstack_src_ip[0] = APSRSTACK_IP_1;
  apsrstack_src_ip[1] = APSRSTACK_IP_2;
  apsrstack_src_ip[2] = APSRSTACK_IP_3;
  apsrstack_src_ip[3] = APSRSTACK_IP_4;

  /* Set all of the TCP queue to connection state LISTEN */
  for(c = 0; c < APSRSTACK_TCP_MAX_CONNECTIONS; c++) 
	  tcp_queue[c].state = APSRSTACK_TCP_STATE_LISTEN;

  for(c = 0; c < APSRSTACK_TCP_MAX_PORTS; c++) 
	  tcp_listen_ports[c] = 0;  

  /* Initialize time for queue scheduler */
  queue_timer.it_interval.tv_sec  = APSRSTACK_TIMER_SEC;
  queue_timer.it_interval.tv_usec = 0;
  queue_timer.it_value.tv_sec     = APSRSTACK_TIMER_SEC;
  queue_timer.it_value.tv_usec    = 0;
  if(signal(SIGALRM, (apsrstack_queue_check_callback)queue_check) == SIG_ERR) {
	  #ifdef APSRSTACK_DEBUG
	  apsr_stream_output(stderr, "Error: Signal error while SIGALRM catching.\n");
          #endif
  }
  setitimer(ITIMER_REAL, &queue_timer, 0);
  
  /* Install some signal handlers */
  if(apsr_install_sig((apsr_exit_callback)clean_exit) == RET_FAILURE) 
	  ERROR("apsr_install_sig failed!");

  service_time_init();
  
  parseoptions(argc, argv);

  service_time_close();
  
  clean_exit(EXIT_SUCCESS); 	
  exit(EXIT_SUCCESS);
}

