/* Type definitions for ICMPv6 */
#define APSR_ICMP6_DEST_UNREA	     1 	     /* Destination unreachable	*/
#define APSR_ICMP6_PACKET_BIG        2       /* Packet too big		*/
#define APSR_ICMP6_TIME_EXCEE        3       /* Time exceeded		*/
#define APSR_ICMP6_PARA_PROBL        4       /* Parameter problem	*/
#define APSR_ICMP6_ECHO_REQUE        128     /* Echo request		*/
#define APSR_ICMP6_ECHO_REPLY        129     /* Echo reply		*/
#define APSR_ICMP6_GROUP_QUER        130     /* Group Membership Query	*/
#define APSR_ICMP6_GROUP_REPO        131     /* Group Membership Report	*/
#define APSR_ICMP6_GROUP_REDU        132     /* Group Membership Reduction */
#define APSR_ICMP6_ROUTER_SOL        133     /* Router Solicitation	*/
#define APSR_ICMP6_ROUTER_ADV        134     /* Router Advertisement	*/
#define APSR_ICMP6_NEIGHB_SOL        135     /* Neighbor Solicitation	*/
#define APSR_ICMP6_NEIGHB_ADV        136     /* Neighbor Advertisement	*/
#define APSR_ICMP6_REDIRECT          137     /* Redirect		*/
#define APSR_ICMP6_ROUTER_REN        138     /* Router renumbering	*/
#define APSR_ICMP6_NODE_QUERY        139     /* ICMP Node Information Query */
#define APSR_ICMP6_NODE_RESPO        140     /* ICMP Node Information Response */ 
#define APSR_ICMP6_INV_ND_SOL        141     /* Inverse Neighbor Discovery */
					     /* Solicitation Message	*/
#define APSR_ICMP6_INV_ND_ADV        142     /* Inverse Neighbor Discovery */ 
                                             /* Advertisement Message	*/

/* Codes for Destination Unreachable */

#define APSR_ICMP6_CODE_NO_ROUTE     0	     /* No route to destination	*/
#define APSR_ICMP6_CODE_COM_AD_P     1       /* Communication with destination */
					     /* administratively prohibited */
#define APSR_ICMP6_CODE_NOT_ASSI     2       /* Not assigned		*/
#define APSR_ICMP6_CODE_ADDR_UNR     3       /* Address unreachable	*/
#define APSR_ICMP6_CODE_PORT_UNR     4       /* Port unreachable	*/

/* Codes for Time Exceeded */

#define APSR_ICMP6_CODE_HOP_EXCE     0       /* Hop limit exceeded in transit */
#define APSR_ICMP6_CODE_FRA_EXCE     1       /* Fragment reassembly ti. exceeded */

/* Codes for Parameter Problem */

#define APSR_ICMP6_CODE_ERR_HEAD     0       /* Errorneous header field encount. */
#define APSR_ICMP6_CODE_UNR_NEXT     1       /* Unrecognized Next H. t. encount. */
#define APSR_ICMP6_CODE_IP6_OPTI     2       /* Unrecognized IPv6 opt. encount.  */

/* Codes for Router Renumbering */

#define APSR_ICMP6_CODE_ROU_COMM     0       /* Router Renumbering Command */
#define APSR_ICMP6_CODE_ROU_RESU     1       /* Router Renumbering Result  */
#define APSR_ICMP6_CODE_SEQ_RESE     255     /* Sequence Number Reset	   */

