#define APSR_IEEE802_11_FC_LEN 2 	/* Frame Control Len */

/* Types */
#define APSR_IEEE802_11_TYPE_MGMT	0		/* Management */
#define APSR_IEEE802_11_TYPE_CTRL	1		/* Control */
#define APSR_IEEE802_11_TYPE_DATA	2		/* Data */
#define APSR_IEEE802_11_TYPE_RESERVED	3		/* Reserved */

/* Management Subtypes */
#define APSR_IEEE802_11_SUBTYPE_MGMT_ASSOC_REQ	0	/* Association request */
#define	APSR_IEEE802_11_SUBTYPE_MGMT_ASSOC_RES	1	/* Association response */
#define APSR_IEEE802_11_SUBTYPE_MGMT_REASS_REQ	2	/* Reassociation request */
#define APSR_IEEE802_11_SUBTYPE_MGMT_REASS_RES	3	/* Reassociation response */
#define APSR_IEEE802_11_SUBTYPE_MGMT_PROBE_REQ	4	/* Probe request */
#define APSR_IEEE802_11_SUBTYPE_MGMT_PROBE_RES	5	/* Probe response */
#define APSR_IEEE802_11_SUBTYPE_MGMT_BEACON	8	/* Beacon */
#define APSR_IEEE802_11_SUBTYPE_MGMT_ATIM	9	/* Announcement traffic
							   indication message */
#define APSR_IEEE802_11_SUBTYPE_MGMT_DISASSOCI	10	/* Disassociation */
#define APSR_IEEE802_11_SUBTYPE_MGMT_AUTHENTIC	11	/* Authentication */
#define APSR_IEEE802_11_SUBTYPE_MGMT_DEAUTHENT	12	/* Deauthentication */

/* Control Subtypes */
#define APSR_IEEE802_11_SUBTYPE_CTRL_PS_POLL	10	/* Power save poll */
#define APSR_IEEE802_11_SUBTYPE_CTRL_RTS	11	/* Request to send */
#define APSR_IEEE802_11_SUBTYPE_CTRL_CTS	12	/* Clear to send */
#define APSR_IEEE802_11_SUBTYPE_CTRL_ACK	13	/* Acknowledgement */
#define APSR_IEEE802_11_SUBTYPE_CTRL_CF		14	/* Contention free */
#define APSR_IEEE802_11_SUBTYPE_CTRL_END_ACK	15	/* Acknowledgement end */

/* Data Subtypes */
#define APSR_IEEE802_11_SUBTYPE_DATA_DATA	0	/* Data */
#define APSR_IEEE802_11_SUBTYPE_DATA_CF_ACK	1	/* Contention free acknowledgement */
#define APSR_IEEE802_11_SUBTYPE_DATA_CF_POLL	2	/* Contention free poll */
#define APSR_IEEE802_11_SUBTYPE_DATA_CF_A_POLL 	3	/* Contention free
							   poll and acknowledgement */
#define APSR_IEEE802_11_SUBTYPE_DATA_NULL	4	/* Null */
#define APSR_IEEE802_11_SUBTYPE_DATA_N_CF_ACK	5	/* Contention free acknowledgement without data */
#define APSR_IEEE802_11_SUBTYPE_DATA_N_CF_POLL	6	/* Contention free poll without data */
#define APSR_IEEE802_11_SUBTYPE_DATA_N_CF_A_P 	7	/* Contention free poll and acknowledgement without data */

