#define APSR_PPP_PROTO_IP	0x0021	/* Internet Protocol v4		*/
#define APSR_PPP_PROTO_OSI	0x0023	/* OSI Network Layer		*/
#define APSR_PPP_PROTO_XEROX	0x0025	/* Xerox NS IDP			*/
#define APSR_PPP_PROTO_DECNET	0x0027	/* Decnet Phase IV		*/
#define APSR_PPP_PROTO_APPLE_TALK 0x0029/* AppleTalk			*/
#define APSR_PPP_PROTO_IPX	0x002B	/* IPX				*/
#define APSR_PPP_PROTO_COMPR_TCP 0x002d	/* Compressed TCP 		*/
#define APSR_PPP_PROTO_UNCOM_TCP 0x002f	/* Uncompressed TCP 		*/
#define APSR_PPP_PROTO_BPDU	0x0031	/* Bridging PDU			*/
#define APSR_PPP_PROTO_ST_II	0x0033	/* Stream Protocol (ST-II)	*/
#define APSR_PPP_PROTO_VINES	0x0035	/* Banyan Vines			*/
#define APSR_PPP_PROTO_SNALLC	0x004b	/* SNA over LLC			*/
#define	APSR_PPP_PROTO_IP6	0x0057	/* Internet Protocol v6		*/
#define APSR_PPP_PROTO_802_1d	0x0201	/* 802.11d Hello Packets	*/
#define APSR_PPP_PROTO_LUXCOM	0x0231	/* Luxcom			*/
#define APSR_PPP_PROTO_SNS	0x0233	/* Sigma Network Systems	*/
#define APSR_PPP_PROTO_IPCP	0x8021	/* IPv4 Control Protocol	*/
#define APSR_PPP_PROTO_OSICP	0x8023	/* OSI Network Layer CP		*/
#define APSR_PPP_PROTO_XEROX_IDP 0x8025	/* Xerox NS IDP Protocol	*/
#define APSR_PPP_PROTO_DECNETCP	0x8027	/* Decnet Phase IV CP		*/
#define APSR_PPP_PROTO_ATCP     0x8029	/* AppleTalk Control Protocol	*/
#define APSR_PPP_PROTO_IPXCP	0x802B	/* Novell IPX Control Protocol	*/
#define APSR_PPP_PROTO_BCP	0x8031	/* Bridging NCP			*/
#define APSR_PPP_PROTO_SPCP	0x8033	/* Stream Protocol CP		*/
#define APSR_PPP_PROTO_VINESCP	0x8035	/* Banyan Vines CP		*/
#define APSR_PPP_PROTO_LEX      0x8041	/* Lan Extension Interface Protocol */
#define APSR_PPP_PROTO_SNALLCCP 0x804b	/* SNA over LLC Control Protocol */
#define APSR_PPP_PROTO_SNACP	0x804d  /* SNA Control Protocol */
#define APSR_PPP_PROTO_ECP	0x8053	/* Encryption Control Protocol	*/
#define APSR_PPP_PROTO_IP6CP	0x8057  /* IPv6 Control Protocol	*/
#define APSR_PPP_PROTO_CCP	0x80fd  /* Compression Control Protocol	*/
#define APSR_PPP_PROTO_LCP	0xc021	/* Link Control Protocol	*/
#define APSR_PPP_PROTO_PAP	0xc023	/* Password Authentication Protocol (PAP) */
#define APSR_PPP_PROTO_LQR	0xc025	/* Link Quality Report		*/
#define APSR_PPP_PROTO_BAP	0xc02d	/* Bandwidth Allocation Protocol */
#define APSR_PPP_PROTO_CHA	0xc223	/* Challenge Handshake Authentication */
#define APSR_PPP_PROTO_EAP	0xc227  /* Extensible Authentication Protocol */

/* PPP LCP defines (rfc 1661 & 1700) */
#define APSR_PPP_LCP_CON_REQ	1	/* Configuration-Request	*/
#define APSR_PPP_LCP_CON_ACK	2	/* Configuration-Ack		*/
#define APSR_PPP_LCP_CON_NAK	3	/* Configuration-Nak		*/
#define APSR_PPP_LCP_CON_REJ	4	/* Configuration-Reject		*/
#define APSR_PPP_LCP_TER_REQ	5	/* Termination-Request		*/
#define APSR_PPP_LCP_TER_REP	6	/* Termination-Reply		*/
#define APSR_PPP_LCP_COD_REJ	7	/* Code-Reject			*/
#define APSR_PPP_LCP_PRO_REJ	8	/* Protocol-Reject		*/
#define APSR_PPP_LCP_ECH_REQ	9	/* Echo-Request			*/
#define APSR_PPP_LCP_ECH_REP	10	/* Echo-Reply			*/
#define	APSR_PPP_LCP_DIS_REQ	11	/* Discard-Request		*/
#define APSR_PPP_LCP_IDENTIF	12	/* Identification		*/
#define APSR_PPP_LCP_TIM_REM	13	/* Time-Remaining		*/

#define APSR_PPP_LCP_TYPE_RESERVED	0	/* Reserved		*/
#define APSR_PPP_LCP_TYPE_MRU	1	/* Maximum-Receive-Unit		*/
#define APSR_PPP_LCP_TYPE_ACCM	2	/* Async-Control-Character-Map	*/
#define APSR_PPP_LCP_TYPE_AP	3	/* Authentication-Protocol	*/
#define APSR_PPP_LCP_TYPE_QP	4	/* Quality-Protocol		*/
#define APSR_PPP_LCP_TYPE_MAGIC	5	/* Magic-Number			*/
#define APSR_PPP_LCP_TYPE_RESERVED2	6	/* Reserved		*/
#define APSR_PPP_LCP_TYPE_PFC	7	/* Protocol-Field-Compression	*/
#define APSR_PPP_LCP_TYPE_ACFC	8	/* Address-and-Control-Field-Compression */
#define APSR_PPP_LCP_TYPE_FCS	9	/* FCS-Alternatives (rfc 1570)	*/
#define APSR_PPP_LCP_TYPE_SDP	10	/* Self-Describing-Pad (rfc 1570) */
#define APSR_PPP_LCP_TYPE_NM	11	/* Numbered-Mode		*/
#define APSR_PPP_LCP_TYPE_MLP	12	/* Multi-Link-Procedure (rfc 1570) */
#define APSR_PPP_LCP_TYPE_CALLBACK	13	/* Callback (rfc 1570)		*/
#define APSR_PPP_LCP_TYPE_CT	14	/* Connect-Time			*/
#define APSR_PPP_LCP_TYPE_CF	15	/* Compound-Frames (rfc 1570)	*/
#define APSR_PPP_LCP_TYPE_NDE	16	/* Nominal-Data-Encapsulation	*/
#define APSR_PPP_LCP_TYPE_MMRRU	17	/* Multilink-MRRU (rfc 1990)	*/
#define APSR_PPP_LCP_TYPE_MSSNHF	18	/* Multilink-Short-Sequence-Number-Header-Format (rfc 1990) */
#define APSR_PPP_LCP_TYPE_MED	19	/* Multilink-Endpoint-Discriminator (rfc 1990) */
#define APSR_PPP_LCP_TYPE_PROB	20	/* Proprietary			*/
#define APSR_PPP_LCP_TYPE_DCE	21	/* DCE-Identifier		*/
#define APSR_PPP_LCP_TYPE_MPPLUS	22	/* MP+ Procedure Option (rfc 1934) */
#define APSR_PPP_LCP_TYPE_BACP	23	/* Link Discriminator for BACP (rfc 2125) */
#define APSR_PPP_LCP_TYPE_LCPAUTH	24	/* LCP-Authentication-Option	*/
#define APSR_PPP_LCP_TYPE_COBS	25	/* COBS, Consistent Overhead Byte Stuffing */
#define APSR_PPP_LCP_TYPE_ELISION	26	/* variable Prefix Elision (rfc 2686) */
#define APSR_PPP_LCP_TYPE_MHF	27	/* Multilink header format (rfc 2686) */
#define APSR_PPP_LCP_TYPE_INTER	28	/* Internationalization (rfc 2484) */
#define APSR_PPP_LCP_TYPE_SDL_SDH	29	/* Simple Data Link on SONET/SDH (rfc 2823) */

/* PPP IPCP defines */
#define APSR_PPP_IPCP_CON_REQ	1	/* Configuration-Request	*/
#define APSR_PPP_IPCP_CON_ACK	2	/* Configuration-Ack		*/
#define	APSR_PPP_IPCP_CON_NAK	3	/* Configuration-Nak		*/
#define APSR_PPP_IPCP_CON_REJ	4	/* Configuration-Reject		*/
#define	APSR_PPP_IPCP_TER_REQ	5	/* Termination-Request		*/
#define APSR_PPP_IPCP_TER_ACK	6	/* Termination-Ack		*/
#define APSR_PPP_IPCP_COD_REJ	7	/* Code-Reject			*/

#define APSR_PPP_IPCP_TYPE_IPADDRS	1	/* IP Addresses(deprecated)	*/
#define APSR_PPP_IPCP_TYPE_IPCOMP	2       /* IP-Compression-Protocoli	*/
#define APSR_PPP_IPCP_TYPE_IP		3       /* IP Address		*/
#define APSR_PPP_IPCP_TYPE_MOIP		4       /* Mobile-IPv4		*/
#define APSR_PPP_IPCP_TYPE_PRDNS     129     /* Primary DNS Server Address	*/
#define APSR_PPP_IPCP_TYPE_PRNBNS    130     /* Primary NBNS Server Address	*/
#define APSR_PPP_IPCP_TYPE_SEDNS     131     /* Secondary DNS Server Address	*/
#define APSR_PPP_IPCP_TYPE_SENBNS    132     /* Secondary NBNS Server Address */

/* PPP IPV6CP defines */
#define APSR_PPP_IPV6CP_CON_REQ        1     /* Configuration-Request	*/
#define APSR_PPP_IPV6CP_CON_ACK        2     /* Configuration-Ack	*/
#define APSR_PPP_IPV6CP_CON_NAK        3     /* Configuration-Nak	*/
#define APSR_PPP_IPV6CP_CON_REJ        4     /* Configuration-Reject	*/
#define APSR_PPP_IPV6CP_TER_REQ        5     /* Termination-Request	*/
#define APSR_PPP_IPV6CP_TER_ACK        6     /* Termination-Ack		*/
#define APSR_PPP_IPV6CP_COD_REJ        7     /* Code-Reject		*/

#define APSR_PPP_IPV6CP_TYPE_IDENT     1     /* Interface-Identifier	*/
#define APSR_PPP_IPV6CP_TYPE_IPCOMP    2     /* IPv6-Compression-Protocol	*/

/* PPP ATCP defines */
#define APSR_PPP_ATCP_CON_REQ        1       /* Configuration-Request	*/
#define APSR_PPP_ATCP_CON_ACK        2       /* Configuration-Ack	*/
#define APSR_PPP_ATCP_CON_NAK        3       /* Configuration-Nak	*/
#define APSR_PPP_ATCP_CON_REJ        4       /* Configuration-Reject	*/
#define APSR_PPP_ATCP_TER_REQ        5       /* Termination-Request	*/
#define APSR_PPP_ATCP_TER_ACK        6       /* Termination-Ack		*/
#define APSR_PPP_ATCP_COD_REJ        7       /* Code-Reject		*/

#define APSR_PPP_ATCP_TYPE_APPLETADR	1	/* AppleTalk Address	*/
#define APSR_PPP_ATCP_TYPE_ROUTING	2	/* Routing protocol	*/
#define APSR_PPP_ATCP_TYPE_SUPBROAD	3	/* Suppress Broadcast	*/
#define APSR_PPP_ATCP_TYPE_ATCOMP	4	/* AppleTalk Comp. Protocol	*/
#define APSR_PPP_ATCP_TYPE_RESERV	5	/* Reserved		*/
#define APSR_PPP_ATCP_TYPE_SERVER	6	/* Server Information	*/
#define APSR_PPP_ATCP_TYPE_ZONE		7	/* Zone Information	*/
#define APSR_PPP_ATCP_TYPE_DEFROUTER	8	/* Default Router Address	*/

#define APSR_PPP_ATCP_ROUTING_NONE	0	/* No routing information	*/
#define APSR_PPP_ATCP_ROUTING_RTMP	1	/* AT RTMP		*/
#define APSR_PPP_ATCP_ROUTING_AURP	2       /* AT AURP		*/
#define APSR_PPP_ATCP_ROUTING_AGBP	3       /* AT AGBP		*/

/* PPP IPXCP defines */
#define APSR_PPP_IPXCP_CON_REQ       1       /* Configuration-Request	*/
#define APSR_PPP_IPXCP_CON_ACK       2       /* Configuration-Ack	*/
#define APSR_PPP_IPXCP_CON_NAK       3       /* Configuration-Nak	*/
#define APSR_PPP_IPXCP_CON_REJ       4       /* Configuration-Reject	*/
#define APSR_PPP_IPXCP_TER_REQ       5       /* Termination-Request	*/
#define APSR_PPP_IPXCP_TER_ACK       6       /* Termination-Ack		*/
#define APSR_PPP_IPXCP_COD_REJ       7       /* Code-Reject		*/

#define APSR_PPP_IPXCP_TYPE_NETNUM	1	/* IPX-Network-Number	*/
#define APSR_PPP_IPXCP_TYPE_NODNUM	2	/* IPX-Node-Number	*/
#define APSR_PPP_IPXCP_TYPE_IPXCOMP	3	/* IPX-Compression-Protocol	*/
#define APSR_PPP_IPXCP_TYPE_IPXROUT	4	/* IPX-Routing-Protocol	*/
#define APSR_PPP_IPXCP_TYPE_ROUTNAM	5	/* IPX-Router-Name	*/
#define APSR_PPP_IPXCP_TYPE_CONFCOM	6	/* IPX-Configuration-Complete	*/

/* PPP PAP defines */
#define APSR_PPP_PAP_AUTH_REQ	1	/* Authenticate-Request		*/
#define APSR_PPP_PAP_AUTH_ACK	2	/* Authenticate-Ack		*/
#define APSR_PPP_PAP_AUTH_NAK	3	/* Authenticate-Nak		*/

/* PPP CHAP defines */
#define APSR_PPP_CHAP_CHALLENGE	1	/* Challenge			*/
#define APSR_PPP_CHAP_RESPONSE	2	/* Response			*/
#define APSR_PPP_CHAP_SUCCESS	3	/* Success			*/
#define APSR_PPP_CHAP_FAILURE	4	/* Failure			*/

/* PPP EAP defines */
#define APSR_PPP_EAP_REQUEST    1       /* Request	(rfc 2284)	*/
#define APSR_PPP_EAP_RESPONSE   2       /* Response     (rfc 2284)      */
#define APSR_PPP_EAP_SUCCESS    3       /* Success      (rfc 2284)      */
#define APSR_PPP_EAP_FAILURE    4       /* Failure      (rfc 2284)      */

/* PPP ECP defines */
#define APSR_PPP_ECP_CON_REQ	1       /* Configuration-Request	*/
#define APSR_PPP_ECP_CON_ACK	2       /* Configuration-Ack		*/
#define APSR_PPP_ECP_CON_NAK	3       /* Configuration-Nak		*/
#define APSR_PPP_ECP_CON_REJ	4       /* Configuration-Reject		*/
#define APSR_PPP_ECP_TER_REQ	5       /* Termination-Request		*/
#define APSR_PPP_ECP_TER_ACK	6       /* Termination-Ack		*/
#define APSR_PPP_ECP_COD_REJ	7       /* Code-Reject			*/
#define APSR_PPP_ECP_RES_REQ	14	/* Reset-Request		*/
#define APSR_PPP_ECP_RES_ACK	15      /* Reset-Ack			*/

#define APSR_PPP_ECP_TYPE_OUI	0	/* Organizationally Unique Identifier */
#define APSR_PPP_ECP_TYPE_DESE	1	/* PPP DES Encryption Protocol	      */
#define APSR_PPP_ECP_TYPE_3DESE	2	/* PPP Triple-DES Encryption Protocol */
#define APSR_PPP_ECP_TYPE_DESEBIS	3	/* PPP DES Data Encryption Protocol   */

/* PPP CCP defines */
#define APSR_PPP_CCP_CON_REQ         1  /* Configuration-Request */
#define APSR_PPP_CCP_CON_ACK         2  /* Configuration-Ack */
#define APSR_PPP_CCP_CON_NAK         3  /* Configuration-Nak	*/
#define APSR_PPP_CCP_CON_REJ         4  /* Configuration-Reject	*/
#define APSR_PPP_CCP_TER_REQ         5  /* Termination-Request	*/
#define APSR_PPP_CCP_TER_ACK         6  /* Termination-Ack	*/
#define APSR_PPP_CCP_COD_REJ         7  /* Code-Reject		*/
#define APSR_PPP_CCP_RES_REQ         14 /* Reset-Request (rfc 1962) */ 
#define APSR_PPP_CCP_RES_ACK         15 /* Reset-Ack (rfc 1962)	*/

#define APSR_PPP_CCP_TYPE_OUI        0  /* Organizationally Unique Identifier */
 					/* (rfc 1962)			      */
#define APSR_PPP_CCP_TYPE_PRE1	     1	/* Predictor type 1 (rfc 1962)	*/
#define APSR_PPP_CCP_TYPE_PRE2       2  /* Predictor type 2 (rfc 1962) */
#define APSR_PPP_CCP_TYPE_PUDDLEJUM  3	/* Puddle Jumper (rfc 1962) */
#define APSR_PPP_CCP_TYPE_HPPPC	     16	/* Hewlett-Packard PPC */
#define APSR_PPP_CCP_TYPE_LZS	     17 /* PPP Stac LZS compression Protocol */
#define APSR_PPP_CCP_TYPE_MPPC	     18 /* Microsoft Point-To-Point Comp. P. */
#define APSR_PPP_CCP_TYPE_FZA        19 /* PPP Gandalf FZA compression P. */
#define APSR_PPP_CCP_TYPE_V42 	     20 /* V.42bis compression */
#define APSR_PPP_CCP_TYPE_BSD	     21 /* BSD compression P. */
#define APSR_PPP_CCP_TYPE_LZS_DCP    23 /* PPP LZS-DCP compression P. */
#define APSR_PPP_CCP_TYPE_MVRCA	     24 /* PPP Magnalink Variable Resource compression Algorithm */
#define APSR_PPP_CCP_TYPE_DCE	     25 /* PPP for Data Compression in Data Circuit-Terminating Equipment */
#define APSR_PPP_CCP_TYPE_DEFLATE    26 /* PPP Deflate Protocol */
#define APSR_PPP_CCP_TYPE_V44	     27 /* V.44/LZJH Compression Protocol */

