#include "../include/apsrlib-config.h"

/* Create a EIGRP packet. */
int apsr_eigrp (unsigned char version, unsigned char opcode,
	       unsigned short sum, unsigned int flags,
	       unsigned int seq_num, unsigned int ack_num,
	       unsigned int autosys, const unsigned char *payload,
	       int payload_size, unsigned char *buf)
{
	static struct eigrp_pkt_header eigrp_hdr;

	if(!buf) {
	  #ifdef APSRLIB_DEBUG
          ERROR("apsr_eigrp: !buf");
	  #endif
	  return(RET_FAILURE);
	}

	eigrp_hdr.version	= version;
	eigrp_hdr.opcode	= opcode;
	eigrp_hdr.sum		= apsr_htons(sum);
	eigrp_hdr.flags		= apsr_htonl(flags);
	eigrp_hdr.seq_num	= apsr_htonl(seq_num);
	eigrp_hdr.ack_num	= apsr_htonl(ack_num);
	eigrp_hdr.autosys	= apsr_htonl(autosys);

	/* Check the payload size and copy it to the buffer. */
	if(payload && payload_size) {
	  memcpy(buf + APSR_EIGRP, payload, payload_size);
	}

	memcpy((unsigned char *)buf, (unsigned char *)&eigrp_hdr,
	       APSR_EIGRP);

	return(RET_SUCCESS);
}

