#include "../include/apsrlib-config.h"

/* Create a GRE packet. */
int apsr_gre (unsigned short flags, unsigned short protocol,
	      const unsigned char *payload, int payload_size,
	      unsigned char *buf)
{
	static struct gre_pkt_header gre_hdr;

	if(!buf) {
	  #ifdef APSRLIB_DEBUG
          ERROR("apsr_gre: !buf");
	  #endif
	  return(RET_FAILURE);
	}

	gre_hdr.flags		= apsr_htons(flags);
	gre_hdr.protocol	= apsr_htons(protocol);

	/* Check the payload size and copy it to the buffer. */
	if(payload && payload_size) {
	  memcpy(buf + APSR_GRE, payload, payload_size);
	}

	memcpy((unsigned char *)buf, (unsigned char *)&gre_hdr,
	       APSR_GRE_H);

	return(RET_SUCCESS);
}

