#include "../include/apsrlib-config.h"

/* Create a IFMP packet. */
int apsr_ifmp (unsigned int version, unsigned int opcode, unsigned short sum,
	       const unsigned char *payload, int payload_size,
	       unsigned char *buf)
{
	static struct ifmp_pkt_header ifmp_hdr;

	if(!buf) {
	  #ifdef APSRLIB_DEBUG
          ERROR("apsr_ifmp: !buf");
	  #endif
	  return(RET_FAILURE);
	}

	ifmp_hdr.version	= version;
	ifmp_hdr.opcode		= opcode;
	ifmp_hdr.sum		= apsr_htons(sum);

	/* Check the payload size and copy it to the buffer. */
	if(payload && payload_size) {
	  memcpy(buf + APSR_IFMP, payload, payload_size);
	}

	memcpy((unsigned char *)buf, (unsigned char *)&ifmp_hdr,
	       APSR_IFMP_H);

	return(RET_SUCCESS);
}

