#include "../include/apsrlib-config.h"

/* Create a IPAUTH packet. */
int apsr_ipauth (unsigned int next_header, unsigned int length,
		 unsigned short reserved, unsigned int spi,
		 unsigned int seq_num, const unsigned char *payload,
		 int payload_size, unsigned char *buf)
{
	static struct ipah_pkt_header ipah_hdr;

	if(!buf) {
	  #ifdef APSRLIB_DEBUG
          ERROR("apsr_ipauth: !buf");
	  #endif
	  return(RET_FAILURE);
	}

	ipah_hdr.next_header	= next_header;
	ipah_hdr.length		= length;
	ipah_hdr.reserved	= apsr_htons(reserved);
	ipah_hdr.spi		= apsr_htonl(spi);
	ipah_hdr.seq_num	= apsr_htonl(seq_num);

	/* Check the payload size and copy it to the buffer. */
	if(payload && payload_size) {
	  memcpy(buf + APSR_IPAH, payload, payload_size);
	}

	memcpy((unsigned char *)buf, (unsigned char *)&ipah_hdr,
	       APSR_IPAH);

	return(RET_SUCCESS);
}

