#include "../include/apsrlib-config.h"

int apsr_open_raw_socket (int protocol, int af) {
	static int fd;
	static int one=1;

	#if (__svr4__)
	  void *oneptr=&one;
	#else
	  int  *oneptr=&one;
	#endif

	/* Open a raw socket. */
	if((fd = socket(af, SOCK_RAW, protocol)) == -1)
	{
	  #ifdef APSRLIB_DEBUG
	    ERROR("apsr_open_raw_socket: socket failed.");
	  #endif

	  return(RET_FAILURE);
	}

	if((setsockopt(fd, IPPROTO_IP, IP_HDRINCL, oneptr, sizeof(one))) == -1)
	{
	  #ifdef APSRLIB_DEBUG
	    ERROR(
	      "apsr_open_raw_socket: setsockopt(..., IP_HDRINCL, ...) failed!"
	    );
	  #endif
	  return(RET_FAILURE);
	}

	/* Linux needs setsockopt(fd, SOL_SOCKET, SOL_BROADCAST); ??? */

	return(fd);
}

int apsr_close_raw_socket (int fd) {
	if(close(fd) < 0) {
	  #ifdef APSRLIB_DEBUG
	    ERROR("apsr_close_raw_socket: close failed!");
	  #endif

	  return(RET_FAILURE);
	}

	return(RET_SUCCESS);
}

int apsr_write_raw_socket (int fd, unsigned char *buf, int len, in_addr_t s_ip, int port, int count) {
	struct sockaddr_in sin;
	int c=0, cnt;

	sin.sin_family = AF_INET;
	sin.sin_addr.s_addr = s_ip;
	sin.sin_port = apsr_htons(port);

	for(cnt=0; cnt < count; cnt++) {
		c += sendto(fd, buf, len, 0, (struct sockaddr *) &sin, sizeof(sin));
	}

	return(c);
}


