#include "../include/apsrlib-config.h"

/* Create a TCP packet. */
/* TODO: TCP options! */
int apsr_tcp (unsigned short s_port, unsigned short d_port, unsigned int seq,
	      unsigned int ack, unsigned char flags, unsigned char data_offset,
	      unsigned char res1, unsigned char res2, unsigned short win_size,
	      unsigned short urg_ptr, unsigned short sum,
	      const unsigned char *payload, int payload_size,
	      unsigned char *buf)
{
	static struct tcp_pkt_header tcp_hdr;

	if(!buf) {
	  #ifdef APSRLIB_DEBUG
	  ERROR("apsr_tcp: !buf");
	  #endif
	  return (RET_FAILURE);
	}

	tcp_hdr.src_port	= apsr_htons(s_port);
	tcp_hdr.dst_port	= apsr_htons(d_port);
	tcp_hdr.seq_num		= apsr_htonl(seq);
	tcp_hdr.ack_num		= apsr_htonl(ack);
	tcp_hdr.flags		= flags;
	tcp_hdr.data_offset	= data_offset;
	
	/* Is this correct??? */
	tcp_hdr.reserved	= ((res1 << 4) | 0x0f) & (res2 | 0xf0);
	tcp_hdr.window		= apsr_htons(win_size);
	tcp_hdr.sum		= apsr_htons(sum);
	tcp_hdr.urgent		= apsr_htons(urg_ptr);

        /* Check the payload size and copy it to the buffer. */
	if(payload && payload_size) {
	  memcpy(buf + APSR_TCP, payload, payload_size);
	}

	memcpy((unsigned char *)buf, (unsigned char *)&tcp_hdr,
	       APSR_TCP);

	return(RET_SUCCESS);
}

