#include "../include/apsrlib-config.h"

/* Create a UDP packet. */
int apsr_udp (unsigned short s_port, unsigned short d_port,
	      unsigned short length, unsigned short sum,
	      const unsigned char *payload, int payload_size,
	      unsigned char *buf)
{
	static struct udp_pkt_header udp_hdr;

	if(!buf) {
	  #ifdef APSRLIB_DEBUG
	  ERROR("apsr_udp: !buf");
	  #endif
	  return(RET_FAILURE);
	}

	udp_hdr.src_port	= apsr_htons(s_port);
	udp_hdr.dst_port	= apsr_htons(d_port);
	udp_hdr.length		= apsr_htons(length);
	udp_hdr.sum		= apsr_htons(sum);

	/* Check the payload size and copy it to the buffer. */
	if(payload && payload_size) {
	  memcpy(buf + APSR_UDP, payload, payload_size);
	}

	memcpy((unsigned char *)buf, (unsigned char *)&udp_hdr,
	       APSR_UDP);

	return(RET_SUCCESS);
}

